﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
'Example version 1.00
#if B4A
'ignore DIP related warnings
#IgnoreWarnings: 6
#end if

Sub Class_Globals
	Private xui As XUI
	Private ImageView1 As B4XView
	Private OriginalBmp() As B4XBitmap
	Private bc1 As BitmapCreator
	Private OriginalBC As BitmapCreator
	Private ImageIndex As Int
	Private MouseBitmapCreator As BitmapCreator
	Private LastXORedRect As B4XRect
	Private scale As Float = 1
	Private CLV1 As CustomListView
	Private Panel1 As B4XView 'ignore
	Type PixelGroup (SrcX As Int, SrcY As Int, x As Float, y As Float, dx As Float, dy As Float)
	Private BasePanel As B4XView
	Private DialogCLV As CustomListView
	Private BlurredDialog1 As BlurredDialog
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("1")
	Dim Width, Height As Int
#if B4J
	Width = 600
	Height = 400
	Dim iv As ImageView = ImageView1
	Dim fx As JFX
	iv.MouseCursor = fx.Cursors.NONE
	'add MouseExit event to the ImageView
	Dim jo As JavaObject = iv
	jo.RunMethod("setOnMouseExited", Array(jo.CreateEventFromUI("javafx.event.EventHandler", "MouseExit", True)))
	jo.RunMethod("setPickOnBounds", Array(True)) 'allow mouse events on transparent parts
#else if B4A
	scale = GetDeviceLayoutValues.Scale
	Width = 100%x / scale
	Height = 280
#else if B4i
	Width = GetDeviceLayoutValues.Width
	Height = 280
#end if
	OriginalBmp = Array As B4XBitmap ( _
		xui.LoadBitmapResize(File.DirAssets, "bas-van-brandwijk-588535-unsplash.jpg", Width, Height, False), _
		xui.LoadBitmapResize(File.DirAssets, "blossom-flora-flowers-94015.jpg", Width, Height, False), _
		xui.LoadBitmapResize(File.DirAssets, "berry-delicious-dessert-70861.jpg", Width, Height, False) _
	)
	BlurredDialog1.Initialize
	PrepareMouseEffect
	bc1.Initialize(Width, Height)
	CLV1.DefaultTextBackgroundColor = 0xFF484545
	CLV1.DefaultTextColor = xui.Color_White
	CLV1.AddTextItem("Change Image", "Change_Image")
	CLV1.AddTextItem("Simple Drawing", "SimpleDrawing_Example")
	CLV1.AddTextItem("Pixelate Animation", "MultiPixelate_Example")
	CLV1.AddTextItem("Color Bins", "BinImage_Example")
	CLV1.AddTextItem("Scroll Animation", "Scroll_Example")
	CLV1.AddTextItem("Blurred Dialog", "ShowBlurredDialog_Example")
	CLV1.AddTextItem("Blur", "Blur_Example")
	CLV1.AddTextItem("Draw Gradients", "Gradients_Example")
	CLV1.AddTextItem("Greyscale", "Greyscale_Example")
	CLV1.AddTextItem("Negate", "Negate_Example")
	CLV1.AddTextItem("More Light", "Light_Example")
	CLV1.AddTextItem("Less Light", "Dark_Example")
	CLV1.AddTextItem("Less Red", "LessRed_Example")
	CLV1.AddTextItem("Draw Smilies (skip blending)", "DrawSmilieySkipBlending_Example")
	CLV1.AddTextItem("Draw Smilies (with blending)", "DrawSmilieyWithBlending_Example")
	CLV1.AddTextItem("Draw Smilies From BitmapCreator (skip blending)", "DrawSmilieyFromBitmapCreatorSkipBlending_Example")
	CLV1.AddTextItem("Draw Smilies From BitmapCreator (with blending)", "DrawSmilieyFromBitmapCreatorWithBlending_Example")
	CLV1.AddTextItem("Curve Drawing", "DrawCurved_Example")
	Change_Image
End Sub

Private Sub PrepareMouseEffect
	MouseBitmapCreator.Initialize(80, 80)
	'The MouseBitmapCreator image is used as a mask. 
	Dim cvs As B4XCanvas = CreateCanvas(MouseBitmapCreator.mWidth, MouseBitmapCreator.mHeight)
	cvs.DrawCircle(cvs.TargetRect.CenterX, cvs.TargetRect.CenterY, 25, xui.Color_Red, True, 0)
	Dim offset As Int = 15
	If xui.IsB4i Then offset = 20
	cvs.DrawText("B4X", cvs.TargetRect.Width / 2, offset, xui.CreateDefaultBoldFont(20 / scale), xui.Color_Red, "CENTER")
	cvs.Invalidate
	MouseBitmapCreator.CopyPixelsFromBitmap(cvs.CreateBitmap)
	cvs.Release
	LastXORedRect.Initialize(0, 0, 0, 0)
End Sub

Public Sub ResizeEvent (width As Int, height As Int)
	Dim iw As Int = bc1.mWidth * scale
	Dim ih As Int = bc1.mHeight * scale
	ImageView1.SetLayoutAnimated(0, width / 2 - iw / 2, 0, iw, ih)
	If Panel1.IsInitialized Then Panel1.SetLayoutAnimated(0, ImageView1.Left, ImageView1.Top, ImageView1.Width, ImageView1.Height)
End Sub


Sub CLV1_ItemClick (Index As Int, Value As Object)
	CallSub(Me, Value)
	Update
End Sub

Sub Change_Image
	ImageIndex = (ImageIndex + 1) Mod OriginalBmp.Length
	Dim bmp As B4XBitmap = OriginalBmp(ImageIndex)
	OriginalBC.Initialize(bmp.Width, bmp.Height)
	OriginalBC.CopyPixelsFromBitmap(bmp)
	ResizeEvent(ImageView1.Parent.Width, ImageView1.Parent.Height)
	LastXORedRect.Width = 0
	Select Rnd(0, 3)
		Case 0
			RadarAnimation
		Case 1
			RandomBlocks
		Case 2
			bc1.DrawBitmapCreator(OriginalBC, OriginalBC.TargetRect, 0, 0, True)
			Update
			ImplodeLayout(50)
	End Select
End Sub

Sub Update
	ImageView1.SetBitmap(bc1.Bitmap)
End Sub

#if B4A or B4i
Sub Panel1_Touch (Action As Int, X As Float, Y As Float)
	Dim cx As Int = X / scale
	Dim cy As Int = Y / scale - 50
	
#else if B4J
Sub MouseExit_Event (MethodName As String, Args() As Object) As Object
	If LastXORedRect.Width > 0 Then
		NegateBasedOnBC(LastXORedRect)
		LastXORedRect.Width = 0
		Update	
	End If
	Return True
End Sub

Sub ImageView1_MouseMoved (EventData As MouseEvent)
	Dim cx As Int = EventData.X
	Dim cy As Int = EventData.Y
	Dim Action As Int = 0
#end if
	Dim target As B4XRect
	target.Initialize(cx - MouseBitmapCreator.mWidth / 2, cy - MouseBitmapCreator.mHeight / 2, cx + MouseBitmapCreator.mWidth / 2, cy + MouseBitmapCreator.mHeight / 2)
	If LastXORedRect.Width > 0 Then
		NegateBasedOnBC(LastXORedRect)
	End If
	If Action = 1 Then
		LastXORedRect.Width = 0
	Else
		NegateBasedOnBC(target)
		LastXORedRect = target
	End If
	Update
End Sub

Private Sub NegateBasedOnBC (Target As B4XRect)
	Dim argb As ARGBColor
	For x = Max(0, Target.Left) To Min(bc1.mWidth - 1, Target.Right - 1)
		For y = Max(0, Target.Top) To Min(bc1.mHeight - 1, Target.Bottom - 1)
			If MouseBitmapCreator.IsTransparent(x - Target.Left, y - Target.Top) Then Continue
			bc1.GetARGB(x, y, argb)
			argb.r = Bit.Xor(argb.r, 0xff)
			argb.g = Bit.Xor(argb.g, 0xff)
			argb.b = Bit.Xor(argb.b, 0xff)
			bc1.SetARGB(x, y, argb)
		Next
	Next
End Sub

Sub SimpleDrawing_Example
	Dim bmp As B4XBitmap = CreateBitmapWithText("Testing 1, 2, 3...")
	Dim target As B4XRect
	target.Initialize(10, 80, 10 + bmp.Width, 80 + bmp.Height)
	bc1.DrawBitmap(bmp, target, False)
End Sub


Sub DrawCurved_Example
	Dim bmp As B4XBitmap = CreateBitmapWithText("Testing 1, 2, 3...")
	DrawCurvedBitmap(bmp, 200, 200, 220, 320, 180)
	ImageView1.SetBitmap(bc1.Bitmap)
End Sub

Sub DrawCurvedBitmap (bmp As B4XBitmap, TargetX As Int, TargetY As Int, _
		 StartAngle As Float, EndAngle As Float, Radius As Float)
	Dim temp As BitmapCreator
	temp.Initialize(bmp.Width, bmp.Height)
	temp.CopyPixelsFromBitmap(bmp)
	Dim DeltaAngle As Float = EndAngle - StartAngle
	Dim x, y As Float
	For x = 0 To temp.mWidth - 1 Step 0.5
		Dim alpha As Float = x / temp.mWidth * DeltaAngle + StartAngle
		Dim CosL As Float = CosD(alpha)
		Dim SinL As Float = SinD(alpha)
		Dim ox As Float = TargetX + CosL * Radius
		Dim oy As Float = TargetY + SinL * Radius
		For y = 0 To temp.mHeight - 1 Step 0.5
			bc1.BlendPixel(temp, x, y, ox, oy)
			ox = ox - CosL / 2
			oy = oy - SinL / 2
		Next
	Next
End Sub

Sub CreateBitmapWithText (text As String) As B4XBitmap
	Dim cvs As B4XCanvas = CreateCanvas(300, 40)
	'cvs.DrawRect(cvs.TargetRect, xui.Color_Magenta, True, 0)
	Dim offset As Int = 10
	If xui.IsB4i Then offset = 18
	cvs.DrawText(text, 0, cvs.TargetRect.Height / 2 + offset, xui.CreateDefaultBoldFont(40 / scale), 0xFFE27E00, "LEFT")
	cvs.Invalidate
	Dim bmp As B4XBitmap = cvs.CreateBitmap
	cvs.Release
	Return bmp
End Sub

Private Sub CreateCanvas(width As Int, height As Int) As B4XCanvas
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, width, height)
	Dim cvs As B4XCanvas
	cvs.Initialize(p)
	Return cvs
End Sub


Private Sub RadarAnimation
	Dim delta As Int
	If xui.IsB4J Then delta = 5 Else delta = 10
	Dim cx As Int = bc1.mWidth / 2
	Dim cy As Int = bc1.mHeight / 2
	
	Dim From As Int
	Dim Sign As Int
	For i = -3 To 0
		Select (i + 4) Mod 4
			Case 0
				Sign = 1
				From = -90
			Case 1
				Sign = 1
				From = 0
			Case 2
				Sign = -1
				From = -90
			Case 3
				Sign = -1
				From = 0
		End Select
		For StartAngle = From To From + 90 - delta Step delta
			For y = 0 To cy
				Dim FirstPointX As Int = cx + Sign * (y + 0.0001) * TanD(StartAngle)
				Dim LastPointX As Int = cx + Sign * (y + 0.0001) * TanD(StartAngle+delta)
				For x = Max(0, Min(FirstPointX, LastPointX)) To Min(bc1.mWidth - 1, Max(FirstPointX, LastPointX))
					Dim yy As Int = Max(0, Min(cy + Sign * y, bc1.mHeight - 1))
					bc1.CopyPixel(OriginalBC, x, yy, x, yy)
				Next
			Next
			ImageView1.SetBitmap(bc1.Bitmap)
			#if not (debug)
			'Resumable subs in debug mode are too slow for process intensive code.
			'Run in release mode to see effect.
			Sleep(5)
			#end if
		Next
	Next
End Sub

Private Sub RandomBlocks
	Dim BlockSize As Int = 40
#if DEBUG
	BlockSize = 200
	Log("Run in release mode!!!")
#End If
	Dim RowCount As Int = (OriginalBC.mWidth / BlockSize + 1)
	Dim count As Int = RowCount * (OriginalBC.mHeight / BlockSize + 1)
	Dim rect As B4XRect
	rect.Initialize(0, 0, 0, 0)
	Dim arr(count) As Int
	For i = 0 To count - 1
		arr(i) = i
	Next
	ShuffleArray(arr)
	For i = 0 To count - 1
		Dim vblock As Int = arr(i)
		Dim column As Int = vblock Mod RowCount
		Dim row As Int = vblock / RowCount
		rect.Left = column * BlockSize
		rect.Width = BlockSize
		rect.Top = row * BlockSize
		rect.Height = BlockSize
		bc1.DrawBitmapCreator(OriginalBC, rect, rect.Left, rect.Top, True)
		ImageView1.SetBitmap(bc1.Bitmap)
		Sleep(5)
	Next
	
End Sub

Private Sub BinImage_Example
	Dim BinSize As Int = 50
	Dim argb As ARGBColor
	For x = 0 To bc1.mWidth - 1
		For y = 0 To bc1.mHeight - 1
			bc1.GetARGB(x, y, argb)
			argb.r = Floor(argb.r / BinSize) * BinSize
			argb.g = Floor(argb.g / BinSize) * BinSize
			argb.b = Floor(argb.b / BinSize) * BinSize
			bc1.SetARGB(x, y, argb)
		Next
	Next
End Sub

Private Sub Scroll_Example
	Dim BarWidth As Int = 5
	Dim temp As BitmapCreator
	temp.Initialize(BarWidth, bc1.mHeight)
	Dim r1, r2 As B4XRect
	r1.Initialize(0, 0, BarWidth, bc1.mHeight)
	r2.Initialize(BarWidth, 0, bc1.mWidth, bc1.mHeight)
	For i = 0 To bc1.mWidth - BarWidth Step BarWidth
		temp.DrawBitmapCreator(bc1, r1, 0, 0, True)
		bc1.DrawBitmapCreator(bc1, r2, 0, 0, True)
		bc1.DrawBitmapCreator(temp, r1, bc1.mWidth - BarWidth, 0, True)
		Update
		If xui.IsB4J Then
			Sleep(16)
		Else
			Sleep(5)
		End If
	Next
	bc1.DrawBitmapCreator(OriginalBC, OriginalBC.TargetRect, 0, 0, True)
	Update
End Sub


Private Sub Blur_Example
'	Dim BlurFilter() As Float = Array As Float( _
'		0.0625, 0.125, 0.0625, _
'		0.125, 0.25, 0.125, _
'		0.0625, 0.125, 0.0625 _
'		)
'	ConvolutionFilter3x3(bc1, BlurFilter)
	
	Dim argb As ARGBColor
	Dim sum As ARGBColor
	sum.a = 255
	For x = 1 To bc1.mWidth - 2
		For y = 1 To bc1.mHeight - 2
			sum.r = 0
			sum.g = 0
			sum.b = 0
			For mx = -1 To 1
				For my = -1 To 1
					bc1.GetARGB(x + mx, y + my, argb)
					sum.r = sum.r + argb.r * 0.11
					sum.g = sum.g + argb.g * 0.11
					sum.b = sum.b + argb.b * 0.11
				Next
			Next
			bc1.SetARGB(x, y, sum)
		Next
	Next
End Sub



Sub GreyScale_Example
	Dim argb As ARGBColor
	For x = 0 To bc1.mWidth - 1
		For y = 0 To bc1.mHeight - 1
			bc1.GetARGB(x, y, argb)
			Dim c As Int = argb.r * 0.21 + argb.g * 0.72 + 0.07 * argb.b
			argb.r = c
			argb.g = c
			argb.b = c
			bc1.SetARGB(x, y, argb)
		Next
	Next
End Sub

Sub Negate_Example
	Dim argb As ARGBColor
	For x = 0 To bc1.mWidth - 1
		For y = 0 To bc1.mHeight - 1
			bc1.GetARGB(x, y, argb)
			argb.r = Bit.Xor(argb.r, 0xff)
			argb.g = Bit.Xor(argb.g, 0xff)
			argb.b = Bit.Xor(argb.b, 0xff)
			bc1.SetARGB(x, y, argb)
		Next
	Next
End Sub

Sub Light_Example
	Brightness(1.1)
End Sub

Sub Dark_Example
	Brightness(0.9)
End Sub

Sub Brightness(Factor As Float)
	Dim argb As ARGBColor
	For x = 0 To bc1.mWidth - 1
		For y = 0 To bc1.mHeight - 1
			bc1.GetARGB(x, y, argb)
			argb.r = Min(255, argb.r * Factor)
			argb.g = Min(255, argb.g * Factor)
			argb.b = Min(255, argb.b * Factor)
			bc1.SetARGB(x, y, argb)
		Next
	Next
End Sub

Sub LessRed_Example
	Dim argb As ARGBColor
	For x = 0 To bc1.mWidth - 1
		For y = 0 To bc1.mHeight - 1
			bc1.GetARGB(x, y, argb)
			argb.r = Min(255, argb.r * 0.8)
			argb.g = Min(255, argb.g * 1.1)
			argb.b = Min(255, argb.b * 1.1)
			bc1.SetARGB(x, y, argb)
		Next
	Next
End Sub

Private Sub MultiPixelate_Example
	For i = 21 To 1 Step -2
		If i > 1 Then
			Pixelate(OriginalBC, bc1, i, i)
		Else
			bc1.DrawBitmapCreator(OriginalBC, OriginalBC.TargetRect, 0, 0, True)
		End If
		ImageView1.SetBitmap(bc1.Bitmap)
		Sleep(200)
	Next
End Sub

Sub Pixelate (bcOriginal As BitmapCreator, bcTarget As BitmapCreator, BoxWidth As Int, BoxHeight As Int)
	Dim rect As B4XRect
	rect.Initialize(0, 0, 0, 0)
	For x = 0 To bcOriginal.mWidth - 1 Step BoxWidth
		rect.Left = x
		rect.Right = x + BoxWidth
		For y = 0 To bcOriginal.mHeight - 1 Step BoxHeight
			rect.Top = y
			rect.Bottom = y + BoxHeight
			bcTarget.FillRect(bcOriginal.GetColor(Min(bcOriginal.mWidth - 1, x + BoxWidth / 2), _
				 Min(bcOriginal.mHeight - 1, y + BoxHeight / 2)), rect)
		Next
	Next
End Sub

Sub DrawSmilieySkipBlending_Example
	DrawSmilies(True)
End Sub

Sub DrawSmilieyWithBlending_Example
	DrawSmilies(False)
End Sub

Sub DrawSmilies (SkipBlending As Boolean)
	Dim bmp As B4XBitmap = xui.LoadBitmapResize(File.DirAssets, "smiley.png", 50, 50, False) 'no dips!
	Dim start As Long = DateTime.Now
	Dim r As B4XRect
	r.Initialize(0, 0, 0, 0)
	Dim count As Int
	Do While DateTime.Now < start + 2 * DateTime.TicksPerSecond
		r.Left = Rnd(-10, bc1.mWidth)
		r.Top = Rnd(-10, bc1.mHeight)
		r.Width = bmp.Width
		r.Height = bmp.Height
		bc1.DrawBitmap(bmp, r, SkipBlending)
		count = count + 1
	Loop
	xui.MsgboxAsync($"Number of smilies per second: ${NumberFormat2(count / 2, 0, 0, 0, True)}"$, "DrawSmilies")
	Update
End Sub

Sub DrawSmilieyFromBitmapCreatorSkipBlending_Example
	DrawSmiliesFromBitmapCreator(True)
End Sub

Sub DrawSmilieyFromBitmapCreatorWithBlending_Example
	DrawSmiliesFromBitmapCreator(False)
End Sub

Sub DrawSmiliesFromBitmapCreator (SkipBlending As Boolean)
	Dim bmp As B4XBitmap = xui.LoadBitmapResize(File.DirAssets, "smiley.png", 50, 50, False) 'no dips!
	Dim temp As BitmapCreator
	temp.Initialize(bmp.Width, bmp.Height)
	temp.CopyPixelsFromBitmap(bmp)
	Dim ColoredSmilies As List
	ColoredSmilies.Initialize
	Dim argb As ARGBColor
	For i = 1 To 20
		Dim bc As BitmapCreator
		bc.Initialize(bmp.Width, bmp.Height)
		Dim RandomColor As ARGBColor
		RandomColor.a = 255
		RandomColor.r = Rnd(0, 256)
		RandomColor.g = Rnd(0, 256)
		RandomColor.b = Rnd(0, 256)
		For x = 1 To temp.mWidth - 2
			For y = 1 To temp.mHeight - 2
				temp.GetARGB(x, y, argb)
				If argb.r = 0xff And argb.g = 0xff And argb.b = 0 Then
					bc.SetARGB(x, y, RandomColor)
				Else
					bc.SetARGB(x, y, argb)
				End If
			Next
		Next
		ColoredSmilies.Add(bc)
	Next
	
		
	Dim start As Long = DateTime.Now
	Dim count As Int
	Do While DateTime.Now < start + 2 * DateTime.TicksPerSecond
		Dim bc As BitmapCreator = ColoredSmilies.Get(Rnd(0, ColoredSmilies.Size))
		bc1.DrawBitmapCreator(bc, bc.TargetRect, Rnd(-10, bc1.mWidth), Rnd(-10, bc1.mHeight), SkipBlending)
		count = count + 1
	Loop
	xui.MsgboxAsync($"Number of smilies per second: ${NumberFormat2(count / 2, 0, 0, 0, True)}"$, "DrawSmiliesFromBitmapCreator")
	Update
End Sub

Sub Gradients_Example
	Dim orientations() As String = Array As String("TL_BR", "TOP_BOTTOM", "TR_BL", "LEFT_RIGHT", "RECTANGLE", "RIGHT_LEFT", "BL_TR", "BOTTOM_TOP" ,"BR_TL")
	Dim clrs1() As Int = Array As Int(0xFFFF6464, 0xFFFFFFFF, 0xFFFF6464)
	For i = 1 To 12
		Dim clrs() As Int = Array As Int (clrs1(i Mod 3), clrs1((i + 1) Mod 3), clrs1((i + 2) Mod 3))
		For x = 0 To 2
			For y = 0 To 2
				Dim r As B4XRect
				r.Initialize(x * 150, y * 100, 0, 0)
				r.Width = 100
				r.Height = 70
				bc1.FillGradient(clrs, r, orientations(x + y * 3))
			Next
		Next
		Update
		Sleep(100)
	Next
End Sub

Private Sub ShuffleArray (arr() As Int)
	For i = arr.Length - 1 To 1 Step -1
		Dim j As Int = Rnd(0, i + 1)
		Dim c As Int = arr(i)
		arr(i) = arr(j)
		arr(j) = c
	Next
End Sub

Sub ShowBlurredDialog_Example
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 300dip, 300dip)
	p.LoadLayout("Dialog")
	DialogCLV.DefaultTextBackgroundColor = xui.Color_Transparent
	DialogCLV.sv.Color = xui.Color_Transparent
	p.SetColorAndBorder(0xaa111111, 2dip, 0xFFFFFFFF, 5dip)
	For i = 1 To 30
		DialogCLV.AddTextItem("Item #" & i, i)
	Next
	BlurredDialog1.Show(BasePanel.Parent, p)
	Wait For DialogCLV_ItemClick (Index As Int, Value As Object)
	Log("Selected value: " & Value)
	Wait For (BlurredDialog1.Close) Complete (Closed As Boolean)
End Sub

Public Sub BackKey As ResumableSub
	Wait For (BlurredDialog1.Close) Complete (Closed As Boolean)
	Return Closed
End Sub

Sub ImplodeLayout(NumberOfSteps As Int) As ResumableSub
	#if debug
	Log("Animation disabled in debug mode.")
	Sleep(0)
	Return True
	#End If
	Dim scale As Float = 100dip / 100
	Dim bc As BitmapCreator
	Dim GroupSize As Int = 6
	Dim iv As ImageView
	iv.Initialize("")
	Dim xiv As B4XView = iv
	Dim bmp As B4XBitmap = BasePanel.Snapshot
	BasePanel.Parent.AddView(xiv, BasePanel.Left, BasePanel.Top, BasePanel.Width, BasePanel.Height)
	BasePanel.RemoveViewFromParent
	
	Dim w As Int = xiv.Width / scale / GroupSize
	Dim h As Int = xiv.Height / scale / GroupSize
	bc.Initialize(w * GroupSize, h * GroupSize)
	Dim source As BitmapCreator
	source.Initialize(bc.mWidth, bc.mHeight)
	source.CopyPixelsFromBitmap(bmp)
	
	Dim steps As Int = NumberOfSteps
	Dim pgs(w, h) As PixelGroup
	For x = 0 To w - 1
		For y = 0 To h - 1
			Dim pg As PixelGroup = pgs(x, y)
			pg.SrcX = x * GroupSize
			pg.Srcy = y * GroupSize
			Select Rnd(0, 4)
				Case 0
					pg.x = 0
					pg.y = Rnd(0, bc.mHeight)
				Case 1
					pg.x = bc.mWidth - 1
					pg.y = Rnd(0, bc.mHeight)
				Case 2
					pg.x = Rnd(0, bc.mWidth)
					pg.y = 0
				Case 3
					pg.x = Rnd(0, bc.mWidth)
					pg.y = bc.mHeight - 1
			End Select
			
			pg.dx = (pg.SrcX - pg.x) / steps
			pg.dy = (pg.SrcY - pg.y) / steps
		Next
	Next
	Dim r As B4XRect
	r.Initialize(0, 0, 0, 0)
	For i = 0 To steps - 1
		bc.FillRect(xui.Color_Transparent, bc.TargetRect)
		For x = 0 To w - 1
			For y = 0 To h - 1
				Dim pg As PixelGroup = pgs(x, y)
				pg.x = pg.x + pg.dx
				pg.y = pg.y + pg.dy
				r.Left = pg.SrcX
				r.Right = pg.SrcX + GroupSize
				r.Top = pg.SrcY
				r.Bottom = pg.SrcY + GroupSize
				bc.DrawBitmapCreator(source, r, pg.x, pg.y, True)
			Next
		Next
		xiv.SetBitmap(bc.Bitmap)
		Sleep(16)
	Next
	xiv.Parent.AddView(BasePanel, xiv.Left, xiv.Top, xiv.Width, xiv.Height)
	xiv.RemoveViewFromParent
	Return True
End Sub



