﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Private bc As BitmapCreator
	Private BlurScale As Int = 3
	Private BasePanel As B4XView
	Private mPanel As B4XView
End Sub

Public Sub Initialize
	If xui.IsB4i Then
		BlurScale = 4
	End If
	#if DEBUG
	BlurScale = BlurScale * 2
	#End If
End Sub

Public Sub Show(Parent As B4XView, Panel As B4XView)
	mPanel = Panel
	BasePanel= xui.CreatePanel("")
	Dim DeviceScale As Float = 100dip / 100
	Dim ParentBmp As B4XBitmap = Parent.Snapshot.Resize(Parent.Width / BlurScale / DeviceScale, Parent.Height / BlurScale / DeviceScale, False)
	Dim iv As ImageView
	iv.Initialize("")
	Parent.AddView(BasePanel, 0, 0, Parent.Width, Parent.Height)
	BasePanel.AddView(iv, 0, 0, BasePanel.Width, BasePanel.Height)
	bc.Initialize(ParentBmp.Width, ParentBmp.Height)
	bc.CopyPixelsFromBitmap(ParentBmp)
'	Dim n As Long = DateTime.Now
	Blur(3)
'	Main.Page1.Title = DateTime.Now - n
'	Log(DateTime.Now - n)
	Dim xiv As B4XView = iv
	xiv.SetBitmap(bc.Bitmap.Resize(xiv.Width, xiv.Height, False))
	#if b4a
	Dim p As Panel = mPanel
	p.Elevation = 4dip
	p = BasePanel
	p.Elevation = 4dip
	#End If
	Sleep(0)
	BasePanel.AddView(Panel, -Panel.Width, BasePanel.Height / 2 - Panel.Height / 2, Panel.Width, Panel.Height)
	Panel.SetLayoutAnimated(500, BasePanel.Width / 2 - Panel.Width / 2, Panel.Top, Panel.Width, Panel.Height)
	
End Sub

Public Sub Close As ResumableSub
	If BasePanel.IsInitialized And BasePanel.Parent.IsInitialized Then
		mPanel.SetLayoutAnimated(200, -mPanel.Width, mPanel.Top, mPanel.Width, mPanel.Height)
		Sleep(200)
		BasePanel.RemoveViewFromParent
		Return True
	End If
	Return False
End Sub

Private Sub Blur (Count As Int)
	Dim clrs(3) As ARGBColor
	Dim temp As ARGBColor
	Dim m As Int
	For steps = 1 To Count
		For y = 0 To bc.mHeight - 1
			For x = 0 To 2
				bc.GetARGB(x, y, clrs(x))
			Next
			SetAvg(1, y, clrs, temp)
			m = 0
			For x = 2 To bc.mWidth - 2
				bc.GetARGB(x + 1, y, clrs(m))
				m = (m + 1) Mod clrs.Length
				SetAvg(x, y, clrs, temp)
			Next
		Next
		For x = 0 To bc.mWidth - 1
			For y = 0 To 2
				bc.GetARGB(x, y, clrs(y))
			Next
			SetAvg(x, 1, clrs, temp)
			m = 0
			For y = 2 To bc.mHeight - 2
				bc.GetARGB(x, y + 1, clrs(m))
				m = (m + 1) Mod clrs.Length
				SetAvg(x, y, clrs, temp)
			Next
		Next
	Next
End Sub

Private Sub SetAvg(x As Int, y As Int, clrs() As ARGBColor, temp As ARGBColor)
	temp.Initialize
	For Each c As ARGBColor In clrs
		temp.r = temp.r + c.r
		temp.g = temp.g + c.g
		temp.b = temp.b + c.b
	Next
	temp.a = 255
	temp.r = temp.r / clrs.Length
	temp.g = temp.g / clrs.Length
	temp.b = temp.b / clrs.Length
	bc.SetARGB(x, y, temp)
End Sub